#!/usr/bin/env python
#
#    Copyright (C) 2003-2005  James Tauber
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

"""
This script converts shelve property_db files to property_pickle
"""

import sys
import os
import os.path
import shelve
import cPickle as pickle

def usage():
    print 'Usage:', sys.argv[0], '<lfs_root>'
    sys.exit(0)


if len(sys.argv) != 2:
    usage()

lfs_root = sys.argv[1]

for dirpath, dirnames, filenames in os.walk(lfs_root):
    if "/.svn" not in dirpath:
        if "property_db" in filenames:
            db_filename = os.path.join(dirpath, "property_db")
            pickle_filename = os.path.join(dirpath, "property_pickle")
            print "converting %s..." % db_filename,
            d = dict(shelve.open(db_filename))
            f = file(pickle_filename, "w")
            pickle.dump(d, f)
            f.close()
            print "done."
